import java.io.File;
import java.io.IOException;
import java.time.Duration;
import java.time.LocalDateTime;

import org.moeaframework.Analyzer;
import org.moeaframework.Executor;
import org.moeaframework.analysis.plot.Plot;
import org.moeaframework.core.NondominatedPopulation;
import org.moeaframework.core.PopulationIO;
import org.moeaframework.core.Solution;
//import org.moeaframework.problem.DTLZ.mydtlz;
import org.moeaframework.problem.misc.DENT;


public class ReferenceSetGenaration {
	public static void main(String[] args) throws IOException {
		
		String[] algorithms = { "NSGAII","SMS-EMOA","SPEA2","NSGA-III"};
		
		 NondominatedPopulation referenceSet = new NondominatedPopulation();
		 Executor executor = new Executor()
				 .withProblemClass(DENT.class)
				 .withProperty("populationSize", 100)
				 .withMaxEvaluations(30000);
		 int nseeds=5;
		 
		 for (String algorithm : algorithms) {
			  executor.withAlgorithm(algorithm);
			 
			 for (int i = 0; i < nseeds; i++) {
			  referenceSet.addAll(executor.run());
			  }
			  }
		 new Plot()
			.add("DENT", referenceSet)
			.show();
		 PopulationIO.writeObjectives(new File("DentBenchmark.txt"), referenceSet);
	}

}
