package SatelliteMissionPlanning;

import java.awt.List;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.time.Duration;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Arrays;

import org.moeaframework.Analyzer;
import org.moeaframework.Executor;
import org.moeaframework.Instrumenter;
import org.moeaframework.analysis.collector.Accumulator;
import org.moeaframework.analysis.plot.Plot;
import org.moeaframework.core.NondominatedPopulation;
import org.moeaframework.core.Population;
import org.moeaframework.core.PopulationIO;
import org.moeaframework.core.Solution;
import org.moeaframework.core.indicator.IndicatorUtils;
import org.moeaframework.core.variable.EncodingUtils;
import org.moeaframework.util.Vector;

public class RunSMP {

	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		
		// read xlsx file
	//	File myFile = new File("3-30-Random.xlsx");
	//	File myFile = new File("2-100-Clustered.xlsx");
		File myFile = new File("2-100-Clustered.xlsx");

		if (myFile == null) {
			System.err.println("Unable to find the input file.");
			System.exit(-1);
		}
		
		SatelliteProblem satelliteProblemInstance = new SatelliteProblem(myFile);
		
////////// solve the problem using one algorithm		
		
//		String algorithmName="T-R2-EMOA";
//
//		LocalDateTime BeforeRun = LocalDateTime.now();
//		NondominatedPopulation result1 = new Executor().withProblem(satelliteProblemInstance)
//				.withAlgorithm(algorithmName)
//////			    .withAlgorithm("R2-EMOA")
/////////				// .withAlgorithm("NSGAIII")
//				.withMaxEvaluations(1000000)
//				.withProperty("populationSize", 100)
////				.interactively()
//				.run();
//		
//		  
//////		 calculate Hypervolume and IGD
//		 Analyzer analyzer = new
//		 Analyzer().withProblem(satelliteProblemInstance)
////		.includeHypervolume()
////		.withReferencePoint(0,0,0).withIdealPoint(-1, -1,-1);
////		 .includeMyHypervolume();
//		 .includePreferenceBasedHypervolume();
////		 .includePreferenceBasedInvertedGenerationalDistance()
////		 .includePreferenceBasedAvaragedHausdorffDistance();
//		 analyzer.add(algorithmName, result1);
//		 analyzer.printAnalysis();		
//////////		 plot the results
//		new Plot().add(algorithmName, result1).show();
//		
//		PopulationIO.writeObjectives(new File("objectives.txt"), result1);
//////		 for interactive method.
//////		PopulationIO.write(new File("solutions.txt"), result1);
//////////////////////////////////using one specified algorithm
// LocalDateTime AfterRun = LocalDateTime.now();
// Duration duration = Duration.between(BeforeRun, AfterRun);
// double RunningTime = duration.getSeconds();
// System.out.println("RunTime: " + RunningTime + " seconds");
//// System.out.println("There are " + result1.size() + " solutions in total");
//// double profit = 0;
//// double quantity = 0;
//// double quality = 0;
//// double cost = 10;
//// double balance = 10;
//// double timeliness = 0;
//////  print the results
//// for (int i = 0; i < result1.size(); i++) {
//// Solution solution = result1.get(i);
//////  SatelliteProblem.evaluateSolution( solution) ;
//// if (!solution.violatesConstraints()) {
//// double[] objectives = solution.getObjectives();
////
//// System.out.println("Solution " + (i + 1) + ":");
//// System.out.println("    Objective1: " + objectives[0]);
////
//// System.out.println("    Objective2: " + objectives[1]);
////
////// System.out.println("    Objective3: " + objectives[2]);
////// System.out.println("    Objective4: " + objectives[3]);
////// System.out.println("    Objective5: " + objectives[4]);
////// System.out.println("    Objective6: " + objectives[5]);
////// System.out.println("    Binary String: " + solution.getVariable(0));
////
////// profit = objectives[0] < profit ? objectives[0] : profit;
////// quantity = objectives[1] < quantity ? objectives[1] : quantity;
////// quality = objectives[2] < quality ? objectives[2] : quality;
////// cost = objectives[3] < cost ? objectives[3] : cost;
////// balance = objectives[4] < balance ? objectives[4] : balance;
////// timeliness = objectives[5] < timeliness ? objectives[5] : timeliness;
////}
////
////}
////
////
////
//////System.out.println("Best values found for each objective:");
//////System.out.println("profit:" + Math.negateExact((int) profit));
//////System.out.println("quantity:" + Math.negateExact((int) quantity));
//////System.out.println("quality:" + quality * (-1));
//////System.out.println("cost:" + cost);
//////System.out.println("balance:" + balance);
//////System.out.println("timeliness:" + timeliness * (-1));
////
//////PopulationIO.writeObjectives(new File("output.txt"), result1);
//System.out.println("Finish");
////	end  of using one algorithm
		
//		//solve the problem with several algorithms
//		 String[] algorithms = { "r-NSGA-II","R-NSGA-II","CP-NSGA-II","W-NSGA-II","CD-NSGA-II"};
		String[] algorithms = { "T-NSGA-II","T-SMS-EMOA","T-R2-EMOA" };
//		String[] algorithms = { "T-R2-EMOA" };
		 Executor executor = new Executor()
		 .withProblem(satelliteProblemInstance)
//		 .withMaxEvaluations(300000)
		 .withProperty("maxTime", 900000)
		 .withProperty("populationSize", 100);
//		//referenceSet is an aggregated result for all runs
		 
//		 
		 Analyzer analyzer = new Analyzer()
		 .withProblem(satelliteProblemInstance)
////		 .withReferencePoint(0, 0)
////        .withIdealPoint(-1, -1)
////		 .includeHypervolume();
		 .includePreferenceBasedHypervolume()
//		 .includePreferenceBasedInvertedGenerationalDistance()
////		 .includePreferenceBasedAvaragedHausdorffDistance()
		 .showStatisticalSignificance()
		 .showIndividualValues();
		  int nseeds=10;
//
		 for (String algorithm : algorithms) {
			 executor.withAlgorithm(algorithm); 
			 ArrayList<NondominatedPopulation> resultForOneAlgorithm=new ArrayList<NondominatedPopulation>();
			 LocalDateTime BeforeRun = LocalDateTime.now();
			 NondominatedPopulation referenceSet = new NondominatedPopulation();
			 for (int i = 0; i < nseeds; i++) {
				 NondominatedPopulation r=executor.run();
				  referenceSet.addAll(r);
				  resultForOneAlgorithm.add(r);
				  }
		 analyzer.addAll(algorithm, resultForOneAlgorithm);
		 // write result of each algorithm to each .txt file
		 String filename="objectives for "+algorithm+".txt";
		 PopulationIO.writeObjectives(new File(filename), referenceSet);
		 LocalDateTime AfterRun = LocalDateTime.now();
		 Duration duration = Duration.between(BeforeRun, AfterRun);
		 double RunningTime = duration.getSeconds();
		 System.out.println(algorithm+": " + RunningTime + " seconds\n");
		 
		 }
//		 
//////		// print the results
		 analyzer.printAnalysis();
		 System.out.println("Finish");
//////////		 

		
//////////////////////////////////////////generating reference set/////////////////////////////////////////
//		 String[] algorithms = { "r-NSGA-II","R-NSGA-II","CP-NSGA-II","W-NSGA-II","CD-NSGA-II" };
//		 String[] algorithms = { "T-NSGA-II" };
////		 String[] algorithms = { "NSGAII","SMS-EMOA"};
//		 NondominatedPopulation referenceSet = new NondominatedPopulation();
//		 
//		 Executor executor = new Executor()
//				 .withProblem(satelliteProblemInstance)
//				 .withProperty("populationSize", 100)
//				 .withMaxEvaluations(2000000);
//		 int nseeds=1;
//		 
//		 for (String algorithm : algorithms) {
//			  executor.withAlgorithm(algorithm);
//			 
//			 for (int i = 0; i < nseeds; i++) {
//			  referenceSet.addAll(executor.run());
//			  }
//			  }
//		 PopulationIO.writeObjectives(new File("Sat3DBenchmark.txt"), referenceSet);
		 
		 ////////////////////////////////////generating reference set end///////////////////////////////////////////////////
//////		  Filter solutions outside ROI
//		 System.out.println("RS number before truncated:"+referenceSet.size());
//		 int NumOfObj=referenceSet.get(0).getNumberOfObjectives();
////			// set reference point, dimension should be same as NumOfObj
//			double[] referencepoint = { -1, -0.95};
//
//			// set weight vector, dimension should be same as NumOfObj
//			double[] weights = { 0.5,0.5};
//			
//			//set the width, length(and height) of ROI, dimension should be same as NumOfObj
//			double[] ranges={0.1,0.1};
//			
//			// find the position in the reference set that is closest to the reference point, distance can be weighted Euclidean distance, or Chebyshev distance
//	        Solution closestSolution=IndicatorUtils.FindtheClosestSolution(referenceSet, referencepoint, weights);
//	        
//	        double[] minimumBound=new double[NumOfObj];
//	    	double[] maximumBound=new double[NumOfObj];
//			//generate the bounds of ROI
//			for(int i=0;i<NumOfObj;i++)
//			{
//			
//				minimumBound[i]=closestSolution.getObjective(i)-ranges[i];
//				maximumBound[i]=closestSolution.getObjective(i)+ranges[i];
//				System.out.println("Accumulator minbound: "+minimumBound[i]);
//				System.out.println("Accumulator maxbound: "+maximumBound[i]);
//			}
//			
//			
//			NondominatedPopulation resultRS=new NondominatedPopulation();
//			
//			for (Solution solution : referenceSet) {
//				//prune any solutions which exceed the Bound
//				boolean Add=true;
//				for (int i=0; i<solution.getNumberOfObjectives(); i++) {
//					
//						if(solution.getObjective(i)>maximumBound[i]||solution.getObjective(i)<minimumBound[i]){
//							Add=false;
//							break;
//						}
//					}
//				
//				if(Add){
//				Solution clone = solution.copy();
//						
//				resultRS.add(clone);		
//				}
//			}
//			
//	 new Plot().add("ReferenceSet", referenceSet).show();
//		 PopulationIO.writeObjectives(new File("Problem1.pf"), resultRS);	
//		 System.out.println("RS number after truncated:"+resultRS.size());
	 
//		 
		 
//		 
		 
		 
		 
		 
		 
		 
		 
		 
////////////////////////////////////////End Generating Reference set////////////////////////////////////////
		 

	}



}
