package org.moeaframework.core.comparator;


import java.io.Serializable;
import java.util.Comparator;

import org.moeaframework.core.Solution;
import static org.moeaframework.core.FitnessEvaluator.GD_ATTRIBUTE;

public class GenerationalDistanceComparator implements DominanceComparator, 
Comparator<Solution>, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3480841925433056141L;


	public GenerationalDistanceComparator() {
		super();
	}
	
	public int compare(Solution solution1, Solution solution2) {
		double dis1 = (Double)solution1.getAttribute(GD_ATTRIBUTE);
		double dis2 = (Double)solution2.getAttribute(GD_ATTRIBUTE);

		if (dis1 > dis2) {
			return -1;
		} else if (dis1 < dis2) {
			return 1;
		} else {
			return 0;
		}
	}
}
