package org.moeaframework.core.indicator;

import java.util.ArrayList;
import java.util.List;

import org.moeaframework.core.Indicator;
import org.moeaframework.core.NondominatedPopulation;
import org.moeaframework.core.Solution;

public class PopulationSizeInROI implements Indicator {
	private double[][] Preference;
	private int NumberOfROI;
	private String shape;

	public PopulationSizeInROI(double[][] preference, int num, String shape1) {
		Preference=preference;
		NumberOfROI=num;
		shape=shape1;
	}

	@Override
	public double evaluate(NondominatedPopulation approximationSet) {
		
		int NumResult=0;
		int NumOfObj=approximationSet.get(0).getNumberOfObjectives();
		for(Solution s:approximationSet){
			boolean InROI=false;
			for(int i=0;i<NumberOfROI;i++){
				//check this ROI
				if(shape=="rectangle"){
				double[] min=new double[NumOfObj];
				double[] max=new double[NumOfObj];
				for(int j=0;j<NumOfObj;j++){
					min[j]=Preference[i][j];
					max[j]=Preference[i][j+NumOfObj];
				}
				boolean  inThisRegion=CheckInROIRec(s,min,max); 
								
				if(inThisRegion)
				{
					InROI=true;
				}
				}
				else if(shape=="circle")
				{
					double[] center=new double[NumOfObj];				
					for(int j=0;j<NumOfObj;j++){
						center[j]=Preference[i][j];	
					}
					double radis=Preference[i][NumOfObj];
					boolean  inThisRegion=CheckInROICircle(s,center,radis); 
									
					if(inThisRegion)
					{
						InROI=true;
					}
				}
				
			}
			if(InROI)
			{
				NumResult++;
			}	
		
		}
		return (double)NumResult;
	}
	
	private boolean CheckInROICircle(Solution s, double[] center, double radis) {
		boolean InROI=false;
		int ObjNum=s.getNumberOfObjectives();
		double distance=0;
		for (int i=0;i<ObjNum;i++)
		{
			distance+=Math.pow(Math.abs(s.getObjective(i)- center[i]),2);
		
		}
		if (distance <= Math.pow(radis, 2))// in the region
		{
			InROI=true;
		}
		
		
		return InROI;
	}

	public boolean CheckInROIRec(Solution s, double[] minBound, double[] maxBound){
		boolean InROI=true;
		for(int i=0;i<s.getNumberOfObjectives();i++)
			if((s.getObjective(i)>maxBound[i])||(s.getObjective(i)<minBound[i])){
				InROI=false;
				break;			
		}
		return InROI;
	}

}
