package org.moeaframework.core.indicator;

import org.moeaframework.Analyzer;
import org.moeaframework.core.NondominatedPopulation;
import org.moeaframework.core.Problem;

public class RPBasedConvergence extends NormalizedIndicator {
	
	public RPBasedConvergence(Problem problem, NondominatedPopulation referenceSet, double[][]RP) {
		super(problem, referenceSet);
		Preference=RP;
	}

	private double[][] Preference;

	@Override
	public double evaluate(NondominatedPopulation approximationSet) {
		double result=0;
		int NumOfObj=approximationSet.get(0).getNumberOfObjectives();
		int NumberOfRP=Analyzer.NumOfROI;
		double[]values=new double[NumberOfRP];
	
		for(int i=0;i<NumberOfRP;i++){
		 double[] ReferencePoint=new double[NumOfObj];
			for(int j=0;j<NumOfObj;j++){
				ReferencePoint[j]=Preference[i][j];
			}
			
			values[i]=IndicatorUtils.FindtheClosestDistance(approximationSet, ReferencePoint);
			result+=values[i];
		}			
		
		result=result/NumberOfRP; // average of distance to each RP
			
		return result; // sum of distance to each RP
	}
	
	

}
