package org.moeaframework.problem.misc;

import org.moeaframework.core.Solution;
import org.moeaframework.core.variable.EncodingUtils;
import org.moeaframework.core.variable.RealVariable;
import org.moeaframework.problem.AbstractProblem;

public class DENT extends AbstractProblem{

	public DENT() {
		super(2, 2);
		// TODO Auto-generated constructor stub
	}

	@Override
	public void evaluate(Solution solution) {
		double[] x = EncodingUtils.getReal(solution);
		double[] f = new double[numberOfObjectives];
		
		double lambda = 0.85;
		double  d = lambda * Math.exp(-1 * Math.pow((x[0] - x[1]),2));

			  
		f[0]= 0.5 * (Math.sqrt(1 + Math.pow(x[0] + x[1],2)) + Math.sqrt(1 + Math.pow(x[0] - x[1],2)) + x[0] - x[1]) + d;
		f[1]= 0.5 * (Math.sqrt(1 + Math.pow(x[0] + x[1],2)) + Math.sqrt(1 + Math.pow(x[0] - x[1],2)) - x[0] + x[1]) + d;
			    
		solution.setObjectives(f);
		
	}

	@Override
	public Solution newSolution() {
		Solution solution = new Solution(getNumberOfVariables(), 
				getNumberOfObjectives());

		for (int i = 0; i < getNumberOfVariables(); i++) {
			solution.setVariable(i, new RealVariable(-1.5, 1.5));
		}

		return solution;
	}

}
